/*   Family Treatment    (1996)          */
/*                                       */
/*   Author : Marie  Aimar               */
/*   File   : parser_family.y            */  

%{

#include <stdio.h>
#include<stdlib.h>
#include <setjmp.h>

#include "generic.h"
#include "list.h"
#include "family.h"
#include "file.h"

static int no_error_line=1;
jmp_buf ENVIRONMENT_BUFFER ;
char *name;
%} 
%union {
 char *t_nom;
 float t_float;
} 

%start set_of_family
%token <t_nom> IDENT
%token <t_float> RATIONAL
%token <entier> FAMILY
%token END_LINE
%type <t_nom> family_number
%type <t_nom> number_of_members
%type <t_nom> identification
%type <t_nom> parent1
%type <t_nom> parent2
%type <t_nom> sexe
%type <t_nom> age
%type <t_nom> proband
%type <t_nom> family_id
%type <t_float> env_fact
%type <t_float> q1
%type <t_float> q2
%type <t_float> q3
%type <t_float> q4
%type <t_float> q5
%%
set_of_family :   /*empty */ 
         | set_of_family family 
         | error {yyerrok;}
         ;

family  :  /* empty */
        | FAMILY END_LINE family_number END_LINE number_of_members 
                    {  no_error_line++;no_error_line++;
		    new_family($3,$5); 
           } END_LINE { no_error_line++;}rest_of_family 
        ;
family_number : IDENT { name = (char *)malloc(1+strlen($1));
                          strcpy(name,$1); $$=name; } 
              ;

number_of_members :  IDENT { name = (char *)malloc(1+strlen($1));
                          strcpy(name,$1);$$=name;}  
                  ;

rest_of_family : /* empty */
               | rest_of_family line 
               ;

line           : /* rien */ END_LINE { no_error_line++; }
               | family_id identification parent1 parent2  sexe age proband proband  END_LINE 
                  {  no_error_line++;
                    add_member($2,$3,$4,$5,$6,$7,$8,0.0,0.0,0.0,0.0,0.0,0.0);}
               | family_id identification parent1 parent2  sexe age proband env_fact q1 q2 q3 q4 q5  END_LINE 
                  {  no_error_line++;
                     add_member($2,$3,$4,$5,$6,NULL,
                                $7,NULL,$8,$9,$10,$11,$12,$13); } 
               | family_id identification parent1 parent2  sexe age proband proband env_fact q1 q2 q3 q4 q5  END_LINE 
                  {  no_error_line++;
                     add_member($2,$3,$4,$5,$6,NULL,$7,$8,$9,$10,$11,$12,$13,$14);} 
               ;    

identification : IDENT{name = (char *)malloc(1+strlen($1));
                       strcpy(name,$1); $$=name; }
               ;
parent1        : IDENT{name = (char *)malloc(1+strlen($1));
                       strcpy(name,$1);$$=name; }
               ;

parent2        : IDENT{name = (char *)malloc(1+strlen($1));
                        strcpy(name,$1);$$=name; };

family_id     : IDENT{};
              
age           : IDENT{$$=atoi($1);};

proband       : IDENT{name = (char *)malloc(1+strlen($1));
                       strcpy(name,$1);$$=name; }
              ;
sexe          : IDENT { $$=atoi($1);}
              ;
env_fact      : RATIONAL{$$=$1;}
              ;
q1            : RATIONAL{$$=$1;}
              ;
q2            : RATIONAL{$$=$1;}
              ;
q3            : RATIONAL{$$=$1;}
              ;
q4            : RATIONAL{$$=$1;}
              ;
q5            : RATIONAL{$$=$1;}
              ;
%%
#include "lex.family.c"
int yyerror(char *s)
{
  printf("%s dans la description des familles a la ligne %d \n Verifier le format du fichier \n  ",s,no_error_line);exit (3);
}
void read_file (FILE *fic_input)
{

  yyin=fic_input;
   if (setjmp(ENVIRONMENT_BUFFER)==0)
     {
	yyparse();
	printf("\n fin de lecture du fichier de description de la famille \n ");
     }
else 
  {
    fclose(fic_input);
  }
}



